/*
 *  author:     john kipps
 *  file:       badchr.c
 *  date:        9-25-1989
 *  summary:    copies garbage characters to another file.
 */

#include <stdio.h>

#define TRUE 1
#define FALSE 0

main(argc,argv)
int argc ;
char *argv[] ;
{
	long int bytes=0L, numcount=0L, punccount=0L, whitecount=0L, wordcnt=1L;
	long int count[26]={0L}, miscount=0L;
	int tmp=0, linecnt=0;
	int i ;
	char prevchar='z', input;
	char filename[13] = "badchr.out" ;
	FILE *fopen(), *fpout, *fpin ;

	if ( argc != 2 )
		{
		fprintf(stderr, "Usage:  badchr  <infile> .  Exiting.\n") ;
		exit();
		}

	fpin  = fopen(argv[1], "r" );
	fpout = fopen(filename, "w" );

	fprintf(stderr, "reading the input...\n");

/*loop
 */
	while (TRUE)
	{

	input = getc(fpin) ;

	if ( input == EOF                      )

		{
		bytes++;
		whitecount++;
       		fprintf(fpout, "\nThe input consisted of %ld characters, including:\n\n"
		       "         digits => %ld\n"
		       "    punctuation => %ld\n"
		       "     whitespace => %ld\n", bytes, numcount, punccount, whitecount);
		for ( i=0; i<26; i++)
			{
			if (count[i] > 0 )
				{
				fprintf(fpout, "            %c\'s => %ld\n", (i+'A'), count[i]);
				}
                        }
                fprintf(fpout, "other characters => %ld .\n", miscount);
                fprintf(fpout, "The  input file contains %ld words in %d lines.\n", wordcnt, linecnt);
                fprintf(fpout, "The output file contains %ld bad characters.\n", miscount);
                fprintf(stderr, "See the bad characters and summary in the file %s .\n", filename);
				putc( '\n', fpout ) ;
                exit();
		}
/* end of execution
 */

	else
        	{
                /* loop for handling every character but the last
                 */
                ++bytes; /*increment the total byte count */

		if (isalpha(input))
			{
			if ( islower(input) ) input = toupper(input) ;
 			tmp = input - 'A';
			count[tmp] = count[tmp] + 1 ;
			}
		else if (isdigit(input))
			{
			numcount++;
			}
		else if (isspace(input))
			{
			whitecount++;
			}
		else if (ispunct(input))
			{
			punccount++;
			}
		else
			{
			miscount++;
			putc(input, fpout) ;
			fprintf(stderr, "bad character %c found in line %hd .\n", input, linecnt+1 );
			}

		/* if first letter after a space, increment the word count
		 */
		if ( !(isspace(input)) && isspace(prevchar) )
			{
			wordcnt++;
			}

		/* if new line, increment the line count
		 */
		if ( input == '\012' )
			{
			linecnt++;
			}

		prevchar = input ;
		}/* end of loop for processing any character
		  */

        } /* end while loop */
} /* end main */


int isspace(ch)
char ch;
{
	if ( ch == ' ' || ch == '\n' || ch == '\t' )
        	{
                return TRUE ;
                }
        else
		{
                return FALSE ;
                }
}
int isalpha(ch)
char ch;
{
	if ( (ch >= 'A' && ch <= 'Z') || (ch>= 'a' && ch <= 'z') )
        	{
                return TRUE ;
                }
        else
		{
                return FALSE ;
                }
}
int isdigit(ch)
char ch;
{
	if ( ch >= '0' && ch <= '9' )
        	{
                return TRUE ;
                }
        else
		{
                return FALSE ;
                }
}
int islower(ch)
char ch;
{
	if ( ch >= 'a' && ch <= 'z')
        	{
                return TRUE ;
                }
        else
		{
                return FALSE ;
                }
}
int toupper(ch)
char ch;
{
	if ( ch >= 'a' && ch <= 'z' )
		{
                return ( ch + 'A' - 'a') ;
                }
        else
		{
                return ch ;
                }
}
int ispunct(ch)
char ch;
{
	if ( (ch >= '-' && ch <= '/') || (ch== ':') || (ch== '_') )
        	{
                return TRUE ;
                }
        else
		{
                return FALSE ;
                }
}
